%define ver_major 1.6
%define ver_minor 6

Name: lilypond
Version: %ver_major.%ver_minor
Release: alt0.2

Group: Publishing
Summary: A program for printing sheet music
License: GPL
Url: http://www.lilypond.org
Packager: Yuri N. Sedunov <aris@altlinux.ru>

Source: ftp://ftp.%name.org/pub/LilyPond/%ver_major/%name-%version.tar.gz
Patch:%name-1.6.6-alt-gcc_no_warnings.patch
Patch1: %name-1.6.6-alt-no-gcc_ver_configure.patch

%define gs_ver 7.05-alt10
%define mftrace_ver 1.0.12
%define tex_ver 2.0

PreReq: tetex >= %tex_ver, ghostscript >= %gs_ver
BuildPreReq: autoconf = 2.13, ghostscript >= %gs_ver
BuildPreReq: mftrace >= %mftrace_ver tetex-devel >= %tex_ver

# Automatically added by buildreq on Wed Dec 25 2002
#BuildRequires: XFree86-libs XFree86-locales autotrace emacs-common emacs-jdee emacs-leim emacs-mode-auctex flex freetype2 gcc-c++ ghostscript-common ghostscript-module-X glib gpm guile-devel ispell-en libImageMagick libXaw3d libgimp-print libjpeg liblcms libstdc++-devel libtiff libungif mftrace netpbm pfaedit pstoedit-devel python-devel t1utils tetex-core tetex-devel tetex-dvips tetex-fonts-source tetex-latex urw-fonts words xpm
BuildRequires: XFree86-libs XFree86-locales autotrace emacs-common emacs-leim
BuildRequires: flex freetype2 gcc-c++ ghostscript-common ghostscript-module-X 
BuildRequires: glib gpm guile-devel ispell-en libImageMagick libXaw3d libgimp-print
BuildRequires: libjpeg liblcms libstdc++-devel libtiff libungif mftrace netpbm pfaedit
BuildRequires: pstoedit-devel python-devel t1utils tetex-core tetex-devel
BuildRequires: tetex-dvips tetex-fonts-source tetex-latex urw-fonts xpm

%description
LilyPond is a music typesetter. It produces beautiful sheet music using
a high level description file as input. Lilypond is part of the GNU
project. This package contains the utilities for converting the music
source (.ly) files into printable output.

%package doc
Summary: LilyPond documentation, examples and Mutopia files
Group: Publishing
Conflicts: %name < %version-%release

%description doc
The documentation of LilyPond, both in HTML and PostScript, along with
example input files and the files from the Mutopia project. At present a
part of this documentation may be broken. See http://lilypond.org for
full.

%package -n emacs-mode-%name
Summary: Major mode for editing GNU LilyPond music scores 
Group: Editors
Requires: %name = %version-%release emacs TiMidity++ gv tetex-xdvi

%description -n emacs-mode-%name
emacs-mode-%name provides syntax coloring, inserting tags,
PS-compilation, PS-viewing and MIDI-play.

All Emacs Lisp code is byte-copmpiled, install emacs-mode-%name-el for sources.

%package -n emacs-mode-%name-el
Summary: The Emacs Lisp sources for bytecode included in emacs-mode-%name
Group: Development/Other
Requires: %name = %version-%release

%description -n emacs-mode-%name-el
emacs-mode-%name-el contains the Emacs Lisp sources for the bytecode
included in the emacs-mode-%name package, that extends the Emacs editor.

You need to install emacs-mode-%name-el only if you intend to modify any of the
emacs-mode-%name code or see some Lisp examples.

#%%define _texmf %(kpsetool -v '$TEXMF'| %__sed -e "s/\!*//")
%define _texmf %_datadir/texmf
%define _emacs_startscriptsdir %_sysconfdir/emacs/site-start.d
%define __emacsbin %_bindir/emacs
%define _lily_dir %_datadir/%name/%version

%prep
%setup
%patch -p1
%patch1 -p1

%build
%set_autoconf_version 2.13
%__autoconf
./configure --prefix=%_prefix --enable-optimising

# while flex generates old syntax which is not recognized by gcc 3.2.
%__mkdir -p lily/out
%make -C lily out/lexer.cc
%__subst 's,\([^:]\)cerr,\1std::cerr,g' lily/out/lexer.cc

# SMP-incompatible build
%make MAKE_PFA_FILES=1 all
%make -C Documentation
%make local-web

# compile emacs-mode files 
%__emacsbin -batch -f batch-byte-compile %name-*.el

%install
%make_install MAKE_PFA_FILES=1 \
		prefix=%buildroot%_prefix \
		infodir=%buildroot%_infodir \
		mandir=%buildroot%_mandir install

# Move TeX dependent files into system TeX tree locations
%__mkdir_p %buildroot%_texmf/fonts/{afm,source,tfm}
%__mv %buildroot%_lily_dir/fonts/afm %buildroot%_texmf/fonts/afm/%name/
%__mv %buildroot%_lily_dir/fonts/source %buildroot%_texmf/fonts/source/%name/
%__mv %buildroot%_lily_dir/fonts/tfm %buildroot%_texmf/fonts/tfm/%name/
%__mkdir_p %buildroot%_texmf/tex
%__mv %buildroot%_lily_dir/tex %buildroot%_texmf/tex/%name/

# remove useless files
%__rm -rf %buildroot%_lily_dir/{make,stepmake,config.make}

# Create documentation tree in %_docdir
%__mkdir_p %buildroot%_docdir/%name-%version/HTML
%__tar -C %buildroot%_docdir/%name-%version/HTML -xzf out/web.tar.gz
%__mkdir_p %buildroot%_docdir/%name-%version/Printable
%__ln_s ../HTML/Documentation/user/out-www/lilypond.ps.gz %buildroot%_docdir/%name-%version/Printable/Manual.ps.gz
%__ln_s ../HTML/Documentation/user/out-www/music-glossary.ps.gz %buildroot%_docdir/%name-%version/Printable/Glossary.ps.gz
%__cp *.txt ChangeLog DEDICATION NEWS ROADMAP VERSION %buildroot/%_docdir/%name-%version/

#Temporary hack for documentation readability.
%__rm -f %buildroot%_docdir/%name-%version/HTML/Documentation/user/out-www/lilypond/lilypond.html
%__ln_s ../lilypond.html %buildroot%_docdir/%name-%version/HTML/Documentation/user/out-www/lilypond/lilypond.html

# Install Emacs-mode files 
%__mkdir_p %buildroot{%_emacslispdir,%_emacs_startscriptsdir}
%__install -m 644 %name-{mode,indent,font-lock}.el* %buildroot%_emacslispdir
%__install -m 644 %name-init.el %buildroot%_emacs_startscriptsdir/%name.el

# Create environment scripts
%__cat <<__SH__ > lilypond.sh
# Setup TeX/LaTeX Ghostscript environment for LilyPond.

GS_FONTPATH="%_texmf/fonts/afm/%name:%_lily_dir/fonts/type1"
GS_LIB="%_lily_dir/ps:"\${GS_LIB:=""}
export GS_LIB GS_FONTPATH 
__SH__

%__cat <<__CSH__ > lilypond.csh
# Setup TeX/LaTeX Ghostscript C-shell environment for LilyPond.

setenv GS_FONTPATH "%_texmf/fonts/afm/%name:%_lily_dir/fonts/type1:\$GS_FONTPATH"
setenv GS_LIB "%_lily_dir/ps:\$GS_LIB"
__CSH__

%__mkdir_p %buildroot%_sysconfdir/profile.d
%__install lilypond.sh %buildroot%_sysconfdir/profile.d/lilypond.sh
%__install lilypond.csh %buildroot%_sysconfdir/profile.d/lilypond.csh

%find_lang %name

%post
touch /tmp/.%name-install
find /var/lib/texmf -name 'feta*pk' -or -name 'feta*tfm' -or -name 'parmesan*pk' -or -name 'parmesan*tfm' -print0|
xargs -r0 %__rm -f -- /tmp/.lilypond-install

%install_info %name.info %name-internals.info
%_bindir/mktexlsr ||:

echo 'Please logout first before using LilyPond.'

%preun
%uninstall_info %name.info %name-internals.info

%postun
%_bindir/mktexlsr ||:

%files -f %name.lang
%_bindir/*
%_datadir/%name
%_texmf/*/%name
%_texmf/*/*/%name
%_infodir/*
%_man1dir/*
%_sysconfdir/profile.d/*
%doc %_docdir/%name-%version/*.txt
%doc %_docdir/%name-%version/ChangeLog
%doc %_docdir/%name-%version/DEDICATION
%doc %_docdir/%name-%version/NEWS
%doc %_docdir/%name-%version/ROADMAP
%doc %_docdir/%name-%version/VERSION

%files -n emacs-mode-%name
%config(noreplace) %_emacs_startscriptsdir/%name.el
%_emacslispdir/%name-*.elc

%files -n emacs-mode-%name-el
%_emacslispdir/%name-*.el

%files doc
%_docdir/%name-%version/HTML
%_docdir/%name-%version/Printable

%changelog
* Sat Dec 07 2002 Yuri N. Sedunov <aris@altlinux.ru> 1.6.6-alt0.2
- Rebuild with new TeX.

* Wed Oct 23 2002 Yuri N. Sedunov <aris@altlinux.ru> 1.6.6-alt0.1
- 1.6.6

* Tue May 28 2002 Yuri N. Sedunov <aris@altlinux.ru> 1.4.13-alt1
- 1.4.13 

* Thu Apr 18 2002 Yuri N. Sedunov <aris@altlinux.ru> 1.4.12-alt3
- rebuild with new autotrace

* Tue Mar 19 2002 Yuri N. Sedunov <aris@altlinux.ru> 1.4.12-alt2
- emacs-mode-%name* packages.
- new buildrequires

* Sun Mar 12 2002 Yuri N. Sedunov <aris@altlinux.ru> 1.4.12-alt1
- 1.4.12
- stepmake patch removed, not needed more.
- makedocs patch. (fix building docs with python2.2)

* Fri Jan 25 2002 Yuri N. Sedunov <aris@altlinux.ru> 1.4.9-alt2
- Cleanups

* Fri Nov 30 2001 Yuri N. Sedunov <aris@altlinux.ru> 1.4.9-alt1
- Updated to 1.4.9

* Thu Nov 16 2001 Yuri N. Sedunov <aris@altlinux.ru> 1.4.8-alt3
- Spec cleanup.

* Thu Nov 15 2001 Yuri N. Sedunov <aris@altlinux.ru> 1.4.8-alt2
- configure with --datadir=%_datadir/%name

* Tue Nov 13 2001 Yuri N. Sedunov <aris@altlinux.ru> 1.4.8-alt1
- First build for Sisyphus
